//Dirty trick that mapa.cpp can be linked in MFC show project... :(
#ifdef _WINDOWS
#include "show\stdafx.h"
#else
#include <stdio.h>
#endif
#include <ctype.h>

#include "mapa.h"

char *mapa::load(const char *file) {
	char c;
	FILE *f=fopen(file,"r");
	if (!f) return "Nemohu otevrit soubor s mapou pro cteni!";

	sx=-1;
	X=0,Y=0;
	while (c=tolower(fgetc(f)),c!='\n' && c!=EOF) switch (c) {
		case 's':
			if (sx!=-1) return "Vic nez jeden start!";
			sx=X;sy=0; //no break
		case 'c': case '.':	case ':': case 'x':
			Y=1,m[X++][0]=c;
			break;
		case '\t': case ' ': //rekneme, ze mezery a taby neplati
			break;
		default:
			return "Neznamy znak v mape!";
	}		
	if (X>MAX_MAPA_SIZE) return "Mapa je moc velka!";
	while (c=fgetc(f),c!=EOF) {
		ungetc(c,f);
		for (int i=0;i<X;i++) switch (c=tolower(fgetc(f)),c) {
			case 's':
				if (sx!=-1) return "Vic nez jeden start!";
				sx=i;sy=Y; //no break
			case 'c': case '.': case ':': case 'x':
				m[i][Y]=c;
				break;
			case '\t': case ' ':
				i--; break;  //rekneme, ze mezery a taby neplati
			default:
				return "Neznamy znak v mape!";
		}
		while (c=fgetc(f),c==' ' || c=='\t') {}
		if (c!= '\n' && c!=EOF) return "Mapa neni obdelnikova!";
		if (++Y>MAX_MAPA_SIZE) return "Mapa je moc velka!";
	}
	if (sx==-1) return "Chybi start!";

	fclose(f);
	return 0;
}

char *mapa::save(const char *file) {
	FILE *f=fopen(file,"w");
	if (!f) return "Nemohu otevrit soubor s mapou pro zapis!";
	for (int j=0;j<Y;j++) {
		for (int i=0;i<X;i++) fputc(toupper(m[i][j]),f);
		fputc('\n',f);
	}
	fclose(f);
	return 0;
}

char *mapa::check_trasa(const trasa &t) {
	int x=sx,y=sy,vx=0,vy=0;

	bool crashed=false;
	int len=t.t.size();
	for (int i=0;i<len;i++) {
		int ax=t.t[i].first, ay=t.t[i].second;
		if (ax<-1 || ax>1 || ay<-1 || ay>1) return "V trase nesmi byt zmeny rychlosti vetsi nez 1!";
		vx+=ax; vy+=ay;
		x+=vx; y+=vy;
		if (x<0 || x>=X || y<0 || y>=Y || m[x][y]=='x'
#ifdef CRASH_DAMAGES
			|| (crashed && (vx<-MAX_VEL_AFTER_CRASH || vx>MAX_VEL_AFTER_CRASH || vy<-MAX_VEL_AFTER_CRASH || vy>MAX_VEL_AFTER_CRASH))
#endif
			) { //collision - dont do it
			x-=vx;
			y-=vy;
			vx=vy=0;
			crashed=true;
		}
	}
	if (m[x][y] != 'c') return "Trasa neskoncila v cili!";

	return 0;
}

mapa_colour mapa_colours[]={
	{0x000000,'x'},
	{0x008000,'.'},
	{0x00ff00,':'},
	{0x00ffff,'s'},
	{0xff0000,'c'}
};

char *mapa::importTGA(const char *file) {
	FILE *f=fopen(file,"rb");
	if (!f) return "Nemohu otevrit TGA soubor s mapou pro cteni!";
/* 1*/	if (fgetc(f)!=0) return "Spatny format TGA souboru!";
/* 2*/	if (fgetc(f)!=0) return "Spatny format TGA souboru!";
/* 3*/	if (fgetc(f)!=2) return "Pouze nekomprimovane TGA soubory jsou podporovane!";
/* 4*/	if (fgetc(f)!=0) return "Spatny format TGA souboru!";
/* 5*/	if (fgetc(f)!=0) return "Spatny format TGA souboru!";
/* 6*/	if (fgetc(f)!=0) return "Spatny format TGA souboru!";
/* 7*/	if (fgetc(f)!=0) return "Spatny format TGA souboru!";
/* 8*/	if (fgetc(f)!=0) return "Spatny format TGA souboru!";
/* 9*/	if (fgetc(f)!=0) return "Spatny format TGA souboru!";
/*10*/	if (fgetc(f)!=0) return "Spatny format TGA souboru!";
/*11*/	if (fgetc(f)!=0) return "Spatny format TGA souboru!";
/*12*/	if (fgetc(f)!=0) return "Spatny format TGA souboru!";
/*13*/	X=(unsigned) fgetc(f);
/*14*/	X|=((unsigned) fgetc(f)) << 8;
	if (X > MAX_MAPA_SIZE) return "Moc velky TGA soubor!";
/*15*/	Y=(unsigned) fgetc(f);
/*16*/	Y|=((unsigned) fgetc(f)) << 8;
	if (Y > MAX_MAPA_SIZE) return "Moc velky TGA soubor!";
/*17*/	if (fgetc(f)!=24) return "Pouze 24-bitove soubory TGA!";
/*18*/	if (fgetc(f)!=0) return "Spatny format TGA souboru!";
	int mc_len=sizeof(mapa_colours) / sizeof(mapa_colour);
	for (int j=Y-1;j>=0;j--)
		for (int i=0;i<X;i++) {
			unsigned long col; //in TGA, there is BGR
			col=(unsigned)fgetc(f);
			col|=((unsigned)fgetc(f))<<8;
			col|=((unsigned)fgetc(f))<<16;
			int k;
			for (k=0;k<mc_len;k++) if (mapa_colours[k].rgb==col) break;
			if (k<mc_len) m[i][j]=mapa_colours[k].znak;
			else return "V TGA souboru je pixel spatne barvy!";
		}
	return 0;
}

char *mapa::exportTGA(const char *file) {
	FILE *f=fopen(file,"wb");
	if (!f) return "Nemohu otevrit TGA soubor s mapou pro zapis!";
	if (!f) return "Nemohu otevrit TGA soubor s mapou pro cteni!";
/* 1*/	fputc(0,f); fputc(0,f); fputc(2,f); fputc(0,f); fputc(0,f); fputc(0,f);
/* 7*/	fputc(0,f); fputc(0,f); fputc(0,f); fputc(0,f); fputc(0,f); fputc(0,f);
/*13*/	fputc(X&0xFF,f); fputc((X>>8)&0xFF,f); fputc(Y&0xFF,f); fputc((Y>>8)&0xFF,f);
/*17*/	fputc(24,f); fputc(0,f);
	int mc_len=sizeof(mapa_colours) / sizeof(mapa_colour);
	for (int j=Y-1;j>=0;j--)
		for (int i=0;i<X;i++) {
			int k;
			for (k=0;k<mc_len;k++) if (mapa_colours[k].znak==m[i][j]) break;
			if (k>=mc_len) return "V mape je spatny znak!";
			fputc(mapa_colours[k].rgb&0xFF,f);
			fputc((mapa_colours[k].rgb>>8)&0xFF,f);
			fputc((mapa_colours[k].rgb>>16)&0xFF,f);
		}
	return 0;
}
