#pragma warning (disable: 4786)

#include <stdio.h>

#include "common.h"
#include "trasa.h"
#include "mapa.h"
#include "mapa_solve.h"

int main(int argc, char *argv[]) {
	if (argc < 3) stop("Pouziti: solve soubor_mapy soubor_trasy!");

	mapa map;
	char *ret;
	if (ret=map.load(argv[1]),ret!=0) stop(ret);

	trasa t;
	if (ret=mapa_solve(map,t),ret!=0) stop(ret);

	t.save(argv[2]);

	return 0;
}
