#include <stdio.h>

#include "common.h"
#include "trasa.h"
#include "mapa.h"

int main(int argc, char *argv[]) {
	if (argc < 3) stop("Pouziti: test soubor_mapy soubor_trasy!");

	mapa map;
	char *ret;
	if (ret=map.load(argv[1]),ret!=0) stop(ret);

	trasa t;
	if (ret=t.load(argv[2]),ret!=0) stop(ret);

	//and check it
	if (ret=map.check_trasa(t),ret!=0) stop(ret);

	//hooray
	printf("Trasa je v poradku, ma %d kroku.\n",t.t.size());

	return 0;
}
