// LegendDlg.cpp : implementation file
//

#include "stdafx.h"
#include "show.h"
#include "LegendDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLegendDlg dialog


CLegendDlg::CLegendDlg(CWnd* pParent /*=NULL*/)
	: CMovableDialog()
{
	Create(CLegendDlg::IDD, pParent);
	//{{AFX_DATA_INIT(CLegendDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CLegendDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLegendDlg)
	DDX_Control(pDX, IDC_LEGEND, m_ctlLegend);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLegendDlg, CDialog)
	//{{AFX_MSG_MAP(CLegendDlg)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLegendDlg message handlers

BOOL CLegendDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SetIcon(AfxGetApp()->LoadIcon(IDR_LEGENDICON), TRUE);
	SetIcon(AfxGetApp()->LoadIcon(IDR_LEGENDICON), FALSE);

	// TODO: Add extra initialization here
	InitMovableDialog(IDC_LEGEND,false);
	

	m_iList.Attach(ImageList_LoadImage(AfxGetApp()->m_hInstance,MAKEINTRESOURCE(IDB_LEGEND),16,1,CLR_NONE,IMAGE_BITMAP,LR_CREATEDIBSECTION));
	m_ctlLegend.SetImageList(&m_iList,LVSIL_SMALL);
	m_iList.Detach();

	CRect rc;
	m_ctlLegend.GetClientRect(rc);
	m_ctlLegend.InsertColumn(0,"Legenda mapy",LVCFMT_LEFT,rc.Width(),0);

	m_ctlLegend.SetExtendedStyle(LVS_EX_FULLROWSELECT);
	m_ctlLegend.SetBkColor(RGB(0,0,64));
	m_ctlLegend.SetTextColor(RGB(255,255,128));
	m_ctlLegend.SetTextBkColor(RGB(0,0,64));
	m_ctlLegend.InsertItem(0,"Zakzan polko",0);
	m_ctlLegend.InsertItem(1,"Cesta",1);
	m_ctlLegend.InsertItem(2,"Bezpen a pomal cesta",2);
	m_ctlLegend.InsertItem(3,"Start",3);
	m_ctlLegend.InsertItem(4,"Cl",4);
	m_ctlLegend.InsertItem(5,"Nalezen trasa",5);
	m_ctlLegend.InsertItem(6,"Nalezen trasa kc bezpenou cestu",6);
	m_ctlLegend.InsertItem(7,"Nalezen trasa v cli",7);
	m_ctlLegend.InsertItem(8,"Zastaven auta srkopedpokldaem",8);
	m_ctlLegend.InsertItem(9,"Kam by auto dojelo bez srkopedpokldae",9);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CLegendDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	ApplyMovableDialog(cx,cy);

	LVCOLUMN col;CRect rc;
	col.mask=LVCF_WIDTH;
	m_ctlLegend.GetClientRect(rc);
	col.cx=rc.Width()-1;
	m_ctlLegend.SetColumn(0,&col);
	col.cx=rc.Width();
	m_ctlLegend.SetColumn(0,&col);
}
