#ifndef CMovableDialogByMilanStrakaC2002
#define CMovableDialogByMilanStrakaC2002

#include <vector>

class CMovableDialog : public CDialog
{
public:
	CMovableDialog( );
	CMovableDialog( UINT nIDTemplate, CWnd* pParentWnd = NULL );
	CMovableDialog( LPCTSTR lpszTemplateName, CWnd* pParentWnd = NULL );

	void InitMovableDialog(int resizingArea,bool centerRest);
	void ApplyMovableDialog(int w,int h);

private:
	static BOOL CALLBACK EnumControlsProc(HWND hwnd,LPARAM lParam);

	bool m_bCenterRest;
	int m_intW,m_intH,m_idResizingArea;
	std::vector< std::pair<HWND,RECT> > m_vControls;
};


#endif