// showDlg.h : header file
//

#if !defined(AFX_SHOWDLG_H__A5A8A936_1961_4BC2_B6D2_52F908F39659__INCLUDED_)
#define AFX_SHOWDLG_H__A5A8A936_1961_4BC2_B6D2_52F908F39659__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CShowDlg dialog
#include "MovableDialog.h"
#include "MapStatic.h"
#include "LegendDlg.h"

class CShowDlg : public CMovableDialog
{
// Construction
public:
	CShowDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CShowDlg)
	enum { IDD = IDD_SHOW_DIALOG };
	CString	m_strMapName;
	CString	m_strTrackName;
	BOOL	m_bCheck;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CShowDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	CMapStatic m_ctlMap; friend CMapStatic;
	CLegendDlg *m_dlgLegend;
	mapa m;
	trasa t;

	// Generated message map functions
	//{{AFX_MSG(CShowDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnOk();
	virtual void OnCancel();
	afx_msg void OnLoadmap();
	afx_msg void OnLoadtrack();
	afx_msg void OnLegend();
	afx_msg void OnMapaClick();
	//}}AFX_MSG
	afx_msg void OnGetMinMaxInfo(MINMAXINFO* lpMMI);
	DECLARE_MESSAGE_MAP()
private:
	CString m_strMapPath, m_strTrackPath;
	bool m_bLoadPossible;
	void UpdateLoadPossible(void);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SHOWDLG_H__A5A8A936_1961_4BC2_B6D2_52F908F39659__INCLUDED_)
